require "import"
import "android.widget.*"
import "android.view.*"
import "android.content.Intent"
import "android.net.Uri"
import "android.app.AlertDialog"

activity.setTheme(android.R.style.Theme_DeviceDefault_Light_NoActionBar)
activity.setTitle("روابط التطبيقات")

-- قائمة التطبيقات: {الاسم, الحزمة}
apps = {
  {"فيسبوك", "com.facebook.katana"},
  {"إنستغرام", "com.instagram.android"},
  {"تيليجرام", "org.telegram.messenger"},
  {"واتساب", "com.whatsapp"},
  {"واتساب للأعمال", "com.whatsapp.w4b"},
  {"ماسنجر", "com.facebook.orca"},
  {"Gmail", "com.google.android.gm"},
  {"مساعد Google", "com.google.android.googlequicksearchbox"},
  {"Google Chrome", "com.android.chrome"},
  {"Google Drive", "com.google.android.apps.docs"},
  {"Google Meet", "com.google.android.apps.meetings"},
  {"متجر Play", "com.android.vending"},
  {"YouTube", "com.google.android.youtube"},
  {"Snapchat", "com.snapchat.android"},
  {"TikTok", "com.zhiliaoapp.musically"},
  {"Twitter", "com.twitter.android"},
  {"Discord", "com.discord"},
  {"Skype", "com.skype.raider"},
  {"Viber", "com.viber.voip"},
  {"IMO", "com.imo.android.imoim"},
  {"Line", "jp.naver.line.android"},
  {"Signal", "org.thoughtcrime.securesms"},
  {"WeChat", "com.tencent.mm"},
  {"Zalo", "com.zing.zalo"},
  {"Messenger Lite", "com.facebook.mlite"},
  {"Telegram X", "org.thunderdog.challegram"},
  {"Threads", "com.instagram.threadsapp"},
  {"Facebook Lite", "com.facebook.lite"},
  {"Instagram Lite", "com.instagram.lite"},
  {"Google Duo", "com.google.android.apps.tachyon"},
  {"Yahoo Mail", "com.yahoo.mobile.client.android.mail"},
  {"Reddit", "com.reddit.frontpage"},
  {"Pinterest", "com.pinterest"},
  {"Tumblr", "com.tumblr"},
  {"Clubhouse", "com.clubhouse.app"},
  {"LinkedIn", "com.linkedin.android"},
  {"Kik", "kik.android"},
  {"Bigo Live", "sg.bigo.live"},
  {"Tango", "com.sgiggle.production"},
  {"MeetMe", "com.myyearbook.m"},
  {"VK", "com.vkontakte.android"},
}

-- دالة لفتح التطبيق أو متجر Google Play
function openAppOrPlayStore(pkg, name)
  local pm = activity.getPackageManager()
  local intent = pm.getLaunchIntentForPackage(pkg)
  if intent then
    Toast.makeText(activity, "جاري فتح "..name, Toast.LENGTH_SHORT).show()
    activity.startActivity(intent)
  else
    Toast.makeText(activity, name.." غير مثبت. فتح متجر Google Play", Toast.LENGTH_SHORT).show()
    local playIntent = Intent(Intent.ACTION_VIEW, Uri.parse("https://play.google.com/store/apps/details?id="..pkg))
    activity.startActivity(playIntent)
  end
end

-- تصميم الواجهة
mainLayout = {
  ScrollView,
  layout_width = "fill",
  layout_height = "fill",
  {
    LinearLayout,
    orientation = "vertical",
    layout_width = "match_parent",
    layout_height = "wrap_content",
    padding = "16dp",
    gravity = "center",

    {
      TextView,
      text = "روابط التطبيقات",
      textSize = "24sp",
      textColor = 0xFF000000,
      gravity = "center",
      layout_marginBottom = "16dp",
    },
  }
}

-- تحميل الواجهة
mainView = loadlayout(mainLayout)
container = mainView.getChildAt(0)

-- إنشاء الأزرار للتطبيقات
for i, app in ipairs(apps) do
  local btn = Button(activity)
  btn.setText(app[1])
  btn.setAllCaps(false)
  btn.setLayoutParams(LinearLayout.LayoutParams(-1, -2))
  btn.setOnClickListener(View.OnClickListener{
    onClick = function(v)
      openAppOrPlayStore(app[2], app[1])
    end
  })
  container.addView(btn)
end

-- زر الخروج
local exitBtn = Button(activity)
exitBtn.setText("خروج")
exitBtn.setAllCaps(false)
exitBtn.setLayoutParams(LinearLayout.LayoutParams(-1, -2))
exitBtn.setOnClickListener(View.OnClickListener{
  onClick = function()
    activity.finish()
  end
})
container.addView(exitBtn)

-- زر المساعدة
local helpBtn = Button(activity)
helpBtn.setText("المساعدة")
helpBtn.setAllCaps(false)
helpBtn.setLayoutParams(LinearLayout.LayoutParams(-1, -2))
helpBtn.setOnClickListener(View.OnClickListener{
  onClick = function()
    AlertDialog.Builder(activity)
      .setTitle("المساعدة")
      .setMessage("مرحباً بكم في أداة روابط للتطبيقات.\n\nعند الضغط على أي تطبيق، سيتم فتحه مباشرة إن كان مثبتًا، أو توجيهك إلى متجر Google Play لتثبيته.")
      .setPositiveButton("موافق", nil)
      .show()
  end
})
container.addView(helpBtn)

-- نص التطوير
local devText = TextView(activity)
devText.setText("تطوير: محمد العراقي")
devText.setTextSize(14)
devText.setTextColor(0xFF444444)
devText.setGravity(Gravity.CENTER)
devText.setLayoutParams(LinearLayout.LayoutParams(-1, -2))
container.addView(devText)

-- عرض الواجهة
activity.setContentView(mainView)